//------------------------------------------------------------------------------
const unsigned short TEMP_RESOLUTION = 12;
const int RES_FACTOR_1[4] = {5000, 2500, 1250, 625};
const unsigned int RES_FACTOR_2[4] = {0x0001, 0x0003, 0x0007, 0x000F};
const unsigned int RES_FACTOR_3[4] = {0x8000, 0xC000, 0xE000, 0xF000};
unsigned short  RES_SHIFT;
//------------------------------------------------------------------------------
void WriteLCD(short x1, short y1, unsigned char *s)
{
    unsigned short ss=0;
    //Lcd_Chr(x1, y1, *s);
    //s++ ;
    while(*s)
        {
            //Lcd_Chr_Cp(*s);
            Lcd_Chr(x1, ss+y1, *s);
            s++ ;
            ss++;
        }
}
//------------------------------------------------------------------------------
float Kvad(float kvadrat)
{
    return(kvadrat*kvadrat);
}
//------------------------------------------------------------------------------

// Splash Screen on LCD
void Ar2rSplash(void)
{
    //unsigned char *text="LC Meter";
    
    Lcd_Cmd(LCD_CLEAR);                      // send command  to LCD (clear LCD)

    WriteLCD(1,1,"LC Meter");                       // print string a on LCD, 1st row, 4th column
    //text="by Ar2r";
    WriteLCD(2,2, "by Ar2r");                      // print string a on LCD, 1st row, 4th column
    
    Delay_ms(1500);                          // Waits 2 sec. for splash screen to be shown :)
}
//------------------------------------------------------------------------------

// Returns mask for common cathode 7-seg. display
unsigned short BCDMask(unsigned short num)
{
    unsigned short bmask;

    switch (num)
        {
            case 0 : bmask=(0x3F); break;
            case 1 : bmask=(0x06); break;
            case 2 : bmask=(0x5B); break;
            case 3 : bmask=(0x4F); break;
            case 4 : bmask=(0x66); break;
            case 5 : bmask=(0x6D); break;
            case 6 : bmask=(0x7D); break;
            case 7 : bmask=(0x07); break;
            case 8 : bmask=(0x7F); break;
            case 9 : bmask=(0x6F); break;
        }
        
    return (bmask);
}
//------------------------------------------------------------------------------

// Returns 1 for leap year else returns 0
unsigned short IsLeapYear(unsigned int yea)
{
    unsigned int ty;
    ty=yea%4;
    if(ty==0) return(1);
    else return(0);
}
//------------------------------------------------------------------------------

// Returns number of days in month
unsigned short Days(unsigned short mon, unsigned int ye)
{
    unsigned short tempd;

    switch (mon)
        {
            case  1 : tempd=(31);                break;
            case  2 : tempd=(28+IsLeapYear(ye)); break;
            case  3 : tempd=(31);                break;
            case  4 : tempd=(30);                break;
            case  5 : tempd=(31);                break;
            case  6 : tempd=(30);                break;
            case  7 : tempd=(31);                break;
            case  8 : tempd=(31);                break;
            case  9 : tempd=(30);                break;
            case 10 : tempd=(31);                break;
            case 11 : tempd=(30);                break;
            case 12 : tempd=(31);                break;
        }
    return (tempd);
}
//------------------------------------------------------------------------------

// Returns date od last week in march
unsigned short dstm(unsigned int mye)
{
    unsigned int x;
    unsigned short mdstm=28;

    for(x=2000;x<=mye;x++)
        {
            if(IsLeapYear(x)==1) mdstm--;

            mdstm--;
            if(mdstm<=24) mdstm+=7;
        }
            
    return (mdstm);
}
//------------------------------------------------------------------------------

// Returns date od last week in october
unsigned short dsto(unsigned int yeo)
{
    unsigned short odsto, odstm;

    odstm=dstm(yeo);
    odsto=odstm+3;
    if(odsto>=32) odsto-=7;

    return (odsto);
}
//------------------------------------------------------------------------------

// Converts sensor data byte to integer - (see factory specs of DS18B20 for data format)
unsigned ConTemp(unsigned temp)
{
  unsigned short RES_SHIFT = TEMP_RESOLUTION - 8;
  unsigned int temp_whole, temp_fraction;
  unsigned short i;

  //--- isolate the fraction and make it a 4-digit decimal integer
  temp_fraction = temp & RES_FACTOR_2[RES_SHIFT - 1];
  temp_fraction = temp_fraction * RES_FACTOR_1[RES_SHIFT - 1];
  //--- handle the whole part of temperature value
  temp_whole = temp;

  //--- is temperature negative?
  if ((temp_whole & 0x8000) != 0u) i = 1;              // Yes, i = 1
  else i = 0;                                          // No,  i = 0
  //--- remove the fractional part
  temp_whole >>= RES_SHIFT;
  //--- correct the sign if necessary
  if (i) temp_whole |= RES_FACTOR_3[RES_SHIFT - 1];

  return (temp_whole);
}
//------------------------------------------------------------------------------
