#line 1 "D:/Proekti/LC-Meter/LCMeter.c"
#line 1 "d:/proekti/lc-meter/ar2r.h"

void Ar2rSplash(void);
unsigned short BCDMask(unsigned short num);
unsigned short Days(unsigned short mon, unsigned int ye);
unsigned short IsLeapYear(unsigned int yea);
unsigned ConTemp(unsigned temp);
unsigned short dstm(unsigned int mye);
unsigned short dsto(unsigned int yeo);
void WriteLCD(short x1, short y1, unsigned char *s);
float Kvad(float kvadrat);
#line 21 "D:/Proekti/LC-Meter/LCMeter.c"
unsigned int cntr;
unsigned long freq, F2, temp;
float cap, ind, vr;
float Cx, Lx, Kfr1, Kfr2;
unsigned short state;
unsigned char ch, vrc, *vrs, c2;

void ShowRes(float res, unsigned char *str, unsigned char cm)
{
 unsigned char stri[6], ste[8], c1;
 unsigned short z=0;
 WriteLCD(1, 3, str);
 while(res<1 && z<4)
 {
 res*=1000;
 z++;
 }
 temp=res*100;
 WordToStr(temp, stri);
 ste[0]=stri[0];
 ste[1]=stri[1];
 ste[2]=stri[2];
 if(ste[2]==32) ste[2]='0';
 ste[3]='.';
 ste[4]=stri[3];
 if(ste[4]==32) ste[4]='0';
 ste[5]=stri[4];
 switch(z)
 {
 case 0: c1=' '; break;
 case 1: c1='m'; break;
 case 2: c1=228; break;
 case 3: c1='n'; break;
 case 4: c1='p'; break;

 }
 if(cm==' ') c1=' ';
 ste[6]=c1;
 ste[7]=cm;
 WriteLCD(2,1, ste);
}

void Kas(void)
{
 Delay_ms(300);
}

void CalcFreq(void)
{
 freq=(TMR1H<<8)+TMR1L;
 freq=(cntr*65536)+freq;
}

void ShowFreq(void)
{
 WriteLCD(1,2, "Freq.= ");
 ch=freq/10000000 %10;
 Lcd_Chr(2,1, ch+48);
 ch=freq/1000000 %10;
 Lcd_Chr_Cp(ch+48);
 ch=freq/100000 %10;
 Lcd_Chr_Cp(ch+48);
 ch=freq/10000 %10;
 Lcd_Chr_Cp(ch+48);
 ch=freq/1000 %10;
 Lcd_Chr_Cp(ch+48);
 ch=freq/100 %10;
 Lcd_Chr_Cp(ch+48);
 ch=freq/10 %10;
 Lcd_Chr_Cp(ch+48);
 ch=freq/1 %10;
 Lcd_Chr_Cp(ch+48);
}

void ResetClk(void)
{
 cntr = 0;
 TMR1H= 0;
 TMR1L= 0;
 state= 0;

 PORTA.F0 = 1;
 PORTA.F0 = 0;
}

void EnableIRQ(void)
{
 PIE1 = 0b00000001;
 INTCON = 0b11010000;
}

void DisableIRQ(void)
{
 INTCON.GIE = 0;
 PIE1 = 0;
}

void Cal(void)
{
 Kas();
 EnableIRQ();
 ResetClk();
 while(state==0) {}

 DisableIRQ();
 CalcFreq();
}

void Calibrate(void)
{
 PORTA.F1=1;
 WriteLCD(1,3, "Calibr");
 WriteLCD(2,1, "ating");
 Cal();
 F2=freq;

 PORTA.F1=0;
 Cal();

 Kfr1=Kvad(freq);
 Kfr2=Kvad(F2);
 cap=(Kfr2/(Kfr1-Kfr2))*0.000000001015;
 ind=(1/(39.478417*Kfr1*cap));
}

void interrupt(void)
{
 if(INTCON.INTF)
 {
 state=1;
 INTCON.INTF = 0;
 }
 if(PIR1.TMR1IF)
 {
 cntr++ ;
 PIR1.TMR1IF = 0 ;
 }
}

void main()
{
 Lcd_Config(&PORTB,4,7,0,3,2,1,5);
 TRISB.F0 = 1;
 TRISB.F6 = 1;
 CMCON = 0b00000111;
 TRISA = 0b11111100;




 OPTION_REG = 0b11000000;
 T1CON = 0b00000111;

 Lcd_Cmd(LCD_CURSOR_OFF);



 Calibrate();

 EnableIRQ();
 ResetClk();

 while (1)
 {
 if(state==1)
 {
 DisableIRQ();
 CalcFreq();


 {

 }

 {
 if(PORTA.F3==1)
 {
 vr=cap;
 vrc='F';
 vrs="Cap.=";
 }
 else
 {
 vr=ind;
 vrc='H';
 vrs="Ind.=";
 }
 Cx=((Kfr1/Kvad(freq))-1)*vr;
 if(Cx<0)
 {
 c2='E';
 Cx=0;
 vrc=' ';
 }
 else c2=' ';
 if(freq<4800)
 {
 Cx=0;
 c2='!';
 vrc=' ';
 }
 vrs[5]=c2;
 ShowRes((Cx), vrs, vrc);
 }

 EnableIRQ();
 ResetClk();
 }
 }
}
